"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
  }
  result["default"] = mod;
  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var React = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var useMergeState_1 = __importDefault(require("./hooks/useMergeState"));

var PickerTrigger_1 = __importDefault(require("./PickerTrigger"));

var PickerPanel_1 = __importDefault(require("./PickerPanel"));

var usePickerInput_1 = __importDefault(require("./hooks/usePickerInput"));

var miscUtil_1 = __importStar(require("./utils/miscUtil"));

var uiUtil_1 = require("./utils/uiUtil");

var PanelContext_1 = __importDefault(require("./PanelContext"));

var dateUtil_1 = require("./utils/dateUtil");

var useValueTexts_1 = __importDefault(require("./hooks/useValueTexts"));

var useTextValueMapping_1 = __importDefault(require("./hooks/useTextValueMapping"));

var RangeContext_1 = __importDefault(require("./RangeContext"));

var useRangeDisabled_1 = __importDefault(require("./hooks/useRangeDisabled"));

function reorderValues(values, generateConfig) {
  if (values && values[0] && values[1] && generateConfig.isAfter(values[0], values[1])) {
    return [values[1], values[0]];
  }

  return values;
}

function canValueTrigger(value, index, disabledList, allowEmpty) {
  if (value) {
    return true;
  }

  if (allowEmpty && allowEmpty[index]) {
    return true;
  } // If another one is disabled, this can be trigger


  if (disabledList[(index + 1) % 2]) {
    return true;
  }

  return false;
}

function InnerRangePicker(props) {
  var _classnames_1$default2;

  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'rc-picker' : _props$prefixCls,
      style = props.style,
      className = props.className,
      popupStyle = props.popupStyle,
      dropdownClassName = props.dropdownClassName,
      transitionName = props.transitionName,
      dropdownAlign = props.dropdownAlign,
      getPopupContainer = props.getPopupContainer,
      generateConfig = props.generateConfig,
      locale = props.locale,
      placeholder = props.placeholder,
      autoFocus = props.autoFocus,
      disabled = props.disabled,
      format = props.format,
      _props$picker = props.picker,
      picker = _props$picker === void 0 ? 'date' : _props$picker,
      showTime = props.showTime,
      use12Hours = props.use12Hours,
      _props$separator = props.separator,
      separator = _props$separator === void 0 ? '~' : _props$separator,
      value = props.value,
      defaultValue = props.defaultValue,
      defaultPickerValue = props.defaultPickerValue,
      open = props.open,
      defaultOpen = props.defaultOpen,
      disabledDate = props.disabledDate,
      allowEmpty = props.allowEmpty,
      allowClear = props.allowClear,
      suffixIcon = props.suffixIcon,
      clearIcon = props.clearIcon,
      pickerRef = props.pickerRef,
      inputReadOnly = props.inputReadOnly,
      mode = props.mode,
      onChange = props.onChange,
      onOpenChange = props.onOpenChange,
      onPanelChange = props.onPanelChange,
      _onFocus = props.onFocus,
      onBlur = props.onBlur;
  var containerRef = React.useRef(null);
  var panelDivRef = React.useRef(null);
  var startInputDivRef = React.useRef(null);
  var endInputDivRef = React.useRef(null);
  var separatorRef = React.useRef(null);
  var startInputRef = React.useRef(null);
  var endInputRef = React.useRef(null); // ============================= Misc ==============================

  var formatList = miscUtil_1.toArray(uiUtil_1.getDefaultFormat(format, picker, showTime, use12Hours)); // Active picker

  var _React$useState = React.useState(0),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      activePickerIndex = _React$useState2[0],
      setActivePickerIndex = _React$useState2[1]; // Operation ref


  var operationRef = React.useRef(null);
  var mergedDisabled = React.useMemo(function () {
    if (Array.isArray(disabled)) {
      return disabled;
    }

    return [disabled || false, disabled || false];
  }, [disabled]); // ============================= Value =============================

  var _useMergeState_1$defa = useMergeState_1.default({
    value: value,
    defaultValue: defaultValue,
    defaultStateValue: null,
    postState: function postState(values) {
      return reorderValues(values, generateConfig);
    }
  }),
      _useMergeState_1$defa2 = _slicedToArray(_useMergeState_1$defa, 2),
      mergedValue = _useMergeState_1$defa2[0],
      setInnerValue = _useMergeState_1$defa2[1]; // =========================== View Date ===========================

  /**
   * End view date is use right panel by default.
   * But when they in same month (date picker) or year (month picker), will both use left panel.
   */


  function getEndViewDate(viewDate, values) {
    var compareFunc = dateUtil_1.isSameMonth;

    if (picker === 'month') {
      compareFunc = dateUtil_1.isSameYear;
    }

    if (compareFunc(generateConfig, miscUtil_1.getValue(values, 0), miscUtil_1.getValue(values, 1))) {
      return viewDate;
    }

    return dateUtil_1.getClosingViewDate(viewDate, picker, generateConfig, -1);
  } // Config view panel


  var _useMergeState_1$defa3 = useMergeState_1.default({
    defaultValue: function defaultValue() {
      return defaultPickerValue || miscUtil_1.updateValues(mergedValue, function (viewDate) {
        return getEndViewDate(viewDate, mergedValue);
      }, 1);
    },
    defaultStateValue: null,
    postState: function postState(postViewDates) {
      return postViewDates || [miscUtil_1.getValue(mergedValue, 0) || generateConfig.getNow(), miscUtil_1.getValue(mergedValue, 0) || generateConfig.getNow()];
    }
  }),
      _useMergeState_1$defa4 = _slicedToArray(_useMergeState_1$defa3, 2),
      viewDates = _useMergeState_1$defa4[0],
      setViewDates = _useMergeState_1$defa4[1]; // ========================= Select Values =========================


  var _useMergeState_1$defa5 = useMergeState_1.default({
    defaultStateValue: mergedValue,
    postState: function postState(values) {
      var postValues = values;

      for (var i = 0; i < 2; i += 1) {
        if (mergedDisabled[i] && !miscUtil_1.getValue(postValues, i)) {
          postValues = miscUtil_1.updateValues(postValues, generateConfig.getNow(), i);
        }
      }

      return postValues;
    }
  }),
      _useMergeState_1$defa6 = _slicedToArray(_useMergeState_1$defa5, 2),
      selectedValue = _useMergeState_1$defa6[0],
      setSelectedValue = _useMergeState_1$defa6[1]; // ========================== Hover Range ==========================


  var _React$useState3 = React.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      hoverRangedValue = _React$useState4[0],
      setHoverRangedValue = _React$useState4[1];

  var onDateMouseEnter = function onDateMouseEnter(date) {
    setHoverRangedValue(miscUtil_1.updateValues(selectedValue, date, activePickerIndex));
  };

  var onDateMouseLeave = function onDateMouseLeave() {
    setHoverRangedValue(miscUtil_1.updateValues(selectedValue, null, activePickerIndex));
  }; // ============================= Modes =============================


  var _useMergeState_1$defa7 = useMergeState_1.default({
    value: mode,
    defaultStateValue: [picker, picker]
  }),
      _useMergeState_1$defa8 = _slicedToArray(_useMergeState_1$defa7, 2),
      mergedModes = _useMergeState_1$defa8[0],
      setInnerModes = _useMergeState_1$defa8[1];

  var triggerModesChange = function triggerModesChange(modes, values) {
    setInnerModes(modes);

    if (onPanelChange) {
      onPanelChange(values, modes);
    }
  }; // ========================= Disable Date ==========================


  var _useRangeDisabled_1$d = useRangeDisabled_1.default({
    selectedValue: selectedValue,
    disabled: mergedDisabled,
    disabledDate: disabledDate,
    generateConfig: generateConfig
  }),
      _useRangeDisabled_1$d2 = _slicedToArray(_useRangeDisabled_1$d, 2),
      disabledStartDate = _useRangeDisabled_1$d2[0],
      disabledEndDate = _useRangeDisabled_1$d2[1]; // ============================= Open ==============================


  var _useMergeState_1$defa9 = useMergeState_1.default({
    value: open,
    defaultValue: defaultOpen,
    defaultStateValue: false,
    postState: function postState(postOpen) {
      return mergedDisabled[activePickerIndex] ? false : postOpen;
    },
    onChange: function onChange(newOpen) {
      if (onOpenChange) {
        onOpenChange(newOpen);
      }

      if (!newOpen && operationRef.current && operationRef.current.onClose) {
        operationRef.current.onClose();
      }
    }
  }),
      _useMergeState_1$defa10 = _slicedToArray(_useMergeState_1$defa9, 2),
      mergedOpen = _useMergeState_1$defa10[0],
      triggerInnerOpen = _useMergeState_1$defa10[1];

  var startOpen = mergedOpen && activePickerIndex === 0;
  var endOpen = mergedOpen && activePickerIndex === 1; // ============================= Popup =============================
  // Popup min width

  var _React$useState5 = React.useState(0),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      popupMinWidth = _React$useState6[0],
      setPopupMinWidth = _React$useState6[1];

  React.useEffect(function () {
    if (!mergedOpen && containerRef.current) {
      setPopupMinWidth(containerRef.current.offsetWidth);
    }
  }, [mergedOpen]); // ============================ Trigger ============================

  var _triggerOpen;

  var triggerChange = function triggerChange(newValue) {
    var forceInput = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var values = newValue;
    var startValue = miscUtil_1.getValue(values, 0);
    var endValue = miscUtil_1.getValue(values, 1);

    if (startValue && endValue && !dateUtil_1.isSameDate(generateConfig, startValue, endValue) && generateConfig.isAfter(startValue, endValue)) {
      values = [startValue, null];
      endValue = null;
    }

    setSelectedValue(values);
    var canStartValueTrigger = canValueTrigger(startValue, 0, mergedDisabled, allowEmpty);
    var canEndValueTrigger = canValueTrigger(endValue, 1, mergedDisabled, allowEmpty);
    var canTrigger = values === null || canStartValueTrigger && canEndValueTrigger;

    if (canTrigger) {
      // Trigger onChange only when value is validate
      setInnerValue(values);

      _triggerOpen(false, activePickerIndex, true);

      if (onChange && (!dateUtil_1.isEqual(generateConfig, miscUtil_1.getValue(mergedValue, 0), startValue) || !dateUtil_1.isEqual(generateConfig, miscUtil_1.getValue(mergedValue, 1), endValue))) {
        onChange(values, [startValue ? generateConfig.locale.format(locale.locale, startValue, formatList[0]) : '', endValue ? generateConfig.locale.format(locale.locale, endValue, formatList[0]) : '']);
      }
    } else if (forceInput) {
      // Open miss value panel to force user input
      var missingValueIndex = canStartValueTrigger ? 1 : 0; // Same index means user choice to close picker

      if (missingValueIndex === activePickerIndex) {
        return;
      }

      _triggerOpen(true, missingValueIndex); // Delay to focus to avoid input blur trigger expired selectedValues


      setTimeout(function () {
        var inputRef = [startInputRef, endInputRef][missingValueIndex];

        if (inputRef.current) {
          inputRef.current.focus();
        }
      }, 0);
    }
  };

  _triggerOpen = function triggerOpen(newOpen, index) {
    var preventChangeEvent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    if (newOpen) {
      setActivePickerIndex(index);
      triggerInnerOpen(newOpen);
    } else if (activePickerIndex === index) {
      triggerInnerOpen(newOpen);

      if (!preventChangeEvent) {
        triggerChange(selectedValue);
      }
    }
  };

  var forwardKeyDown = function forwardKeyDown(e) {
    if (mergedOpen && operationRef.current && operationRef.current.onKeyDown) {
      // Let popup panel handle keyboard
      return operationRef.current.onKeyDown(e);
    }

    return false;
  }; // ============================= Text ==============================


  var sharedTextHooksProps = {
    formatList: formatList,
    generateConfig: generateConfig,
    locale: locale
  };
  var startValueTexts = useValueTexts_1.default(miscUtil_1.getValue(selectedValue, 0), sharedTextHooksProps);
  var endValueTexts = useValueTexts_1.default(miscUtil_1.getValue(selectedValue, 1), sharedTextHooksProps);

  var _onTextChange = function onTextChange(newText, index) {
    var inputDate = generateConfig.locale.parse(locale.locale, newText, formatList);
    var disabledFunc = index === 0 ? disabledStartDate : disabledEndDate;

    if (inputDate && !disabledFunc(inputDate)) {
      setSelectedValue(miscUtil_1.updateValues(selectedValue, inputDate, index));
      setViewDates(miscUtil_1.updateValues(viewDates, inputDate, index));
    }
  };

  var _useTextValueMapping_ = useTextValueMapping_1.default({
    valueTexts: startValueTexts,
    onTextChange: function onTextChange(newText) {
      return _onTextChange(newText, 0);
    }
  }),
      _useTextValueMapping_2 = _slicedToArray(_useTextValueMapping_, 3),
      startText = _useTextValueMapping_2[0],
      triggerStartTextChange = _useTextValueMapping_2[1],
      resetStartText = _useTextValueMapping_2[2];

  var _useTextValueMapping_3 = useTextValueMapping_1.default({
    valueTexts: endValueTexts,
    onTextChange: function onTextChange(newText) {
      return _onTextChange(newText, 1);
    }
  }),
      _useTextValueMapping_4 = _slicedToArray(_useTextValueMapping_3, 3),
      endText = _useTextValueMapping_4[0],
      triggerEndTextChange = _useTextValueMapping_4[1],
      resetEndText = _useTextValueMapping_4[2]; // ============================= Input =============================


  var getSharedInputHookProps = function getSharedInputHookProps(index, inputDivRef, resetText) {
    return {
      forwardKeyDown: forwardKeyDown,
      onBlur: onBlur,
      isClickOutside: function isClickOutside(target) {
        return !!(panelDivRef.current && !panelDivRef.current.contains(target) && inputDivRef.current && !inputDivRef.current.contains(target) && onOpenChange);
      },
      onFocus: function onFocus(e) {
        setActivePickerIndex(index);

        if (_onFocus) {
          _onFocus(e);
        }
      },
      triggerOpen: function triggerOpen(newOpen) {
        return _triggerOpen(newOpen, index);
      },
      onSubmit: function onSubmit() {
        triggerChange(selectedValue);

        _triggerOpen(false, index, true);

        resetText();
      },
      onCancel: function onCancel() {
        _triggerOpen(false, index, true);

        setSelectedValue(mergedValue);
        resetText();
      }
    };
  };

  var _usePickerInput_1$def = usePickerInput_1.default(_objectSpread({}, getSharedInputHookProps(0, startInputDivRef, resetStartText), {
    open: startOpen
  })),
      _usePickerInput_1$def2 = _slicedToArray(_usePickerInput_1$def, 2),
      startInputProps = _usePickerInput_1$def2[0],
      _usePickerInput_1$def3 = _usePickerInput_1$def2[1],
      startFocused = _usePickerInput_1$def3.focused,
      startTyping = _usePickerInput_1$def3.typing;

  var _usePickerInput_1$def4 = usePickerInput_1.default(_objectSpread({}, getSharedInputHookProps(1, endInputDivRef, resetEndText), {
    open: endOpen
  })),
      _usePickerInput_1$def5 = _slicedToArray(_usePickerInput_1$def4, 2),
      endInputProps = _usePickerInput_1$def5[0],
      _usePickerInput_1$def6 = _usePickerInput_1$def5[1],
      endFocused = _usePickerInput_1$def6.focused,
      endTyping = _usePickerInput_1$def6.typing; // ============================= Sync ==============================
  // Close should sync back with text value


  React.useEffect(function () {
    if (!mergedOpen) {
      setSelectedValue(mergedValue);
    }
  }, [mergedOpen]); // Sync innerValue with control mode

  React.useEffect(function () {
    // Sync select value
    setSelectedValue(mergedValue);
  }, [mergedValue]); // ============================ Private ============================

  if (pickerRef) {
    pickerRef.current = {
      focus: function focus() {
        if (startInputRef.current) {
          startInputRef.current.focus();
        }
      },
      blur: function blur() {
        if (startInputRef.current) {
          startInputRef.current.blur();
        }

        if (endInputRef.current) {
          endInputRef.current.blur();
        }
      }
    };
  } // ============================= Panel =============================


  function renderPanel() {
    var panelPosition = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var panelProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var panelHoverRangedValue = null;

    if (hoverRangedValue && hoverRangedValue[0] && hoverRangedValue[1] && !dateUtil_1.isSameDate(generateConfig, hoverRangedValue[0], hoverRangedValue[1]) && generateConfig.isAfter(hoverRangedValue[1], hoverRangedValue[0])) {
      panelHoverRangedValue = hoverRangedValue;
    }

    var panelShowTime = showTime;

    if (panelShowTime && _typeof(panelShowTime) === 'object' && panelShowTime.defaultValue) {
      var timeDefaultValues = showTime.defaultValue;
      panelShowTime.defaultValue = miscUtil_1.getValue(timeDefaultValues, activePickerIndex) || undefined;
    }

    return React.createElement(RangeContext_1.default.Provider, {
      value: {
        inRange: true,
        panelPosition: panelPosition,
        rangedValue: selectedValue,
        hoverRangedValue: panelHoverRangedValue
      }
    }, React.createElement(PickerPanel_1.default, Object.assign({}, props, panelProps, {
      showTime: panelShowTime,
      mode: mergedModes[activePickerIndex],
      generateConfig: generateConfig,
      style: undefined,
      disabledDate: activePickerIndex === 0 ? disabledStartDate : disabledEndDate,
      className: classnames_1.default(_defineProperty({}, "".concat(prefixCls, "-panel-focused"), !startTyping && !endTyping)),
      value: miscUtil_1.getValue(selectedValue, activePickerIndex),
      locale: locale,
      tabIndex: -1,
      onMouseDown: function onMouseDown(e) {
        e.preventDefault();
      },
      onSelect: function onSelect(date) {
        var values = miscUtil_1.updateValues(selectedValue, date, activePickerIndex);

        if (picker === 'date' && showTime) {
          setSelectedValue(values);
        } else {
          // triggerChange will also update selected values
          triggerChange(values);
        }
      },
      onPanelChange: function onPanelChange(date, newMode) {
        triggerModesChange(miscUtil_1.updateValues(mergedModes, newMode, activePickerIndex), miscUtil_1.updateValues(selectedValue, date, activePickerIndex));
        setViewDates(miscUtil_1.updateValues(viewDates, date, activePickerIndex));
      },
      onChange: undefined,
      defaultValue: undefined,
      defaultPickerValue: undefined
    })));
  }

  function renderPanels() {
    if (picker !== 'time' && !showTime) {
      var viewDate = viewDates[activePickerIndex];
      var nextViewDate = dateUtil_1.getClosingViewDate(viewDate, picker, generateConfig);
      var currentMode = mergedModes[activePickerIndex];
      var showDoublePanel = currentMode === picker;
      return React.createElement("div", {
        className: "".concat(prefixCls, "-panel-container"),
        ref: panelDivRef
      }, renderPanel(showDoublePanel ? 'left' : false, {
        pickerValue: viewDate,
        onPickerValueChange: function onPickerValueChange(newViewDate) {
          setViewDates(miscUtil_1.updateValues(viewDates, newViewDate, activePickerIndex));
        }
      }), showDoublePanel && renderPanel('right', {
        pickerValue: nextViewDate,
        onPickerValueChange: function onPickerValueChange(newViewDate) {
          setViewDates(miscUtil_1.updateValues(viewDates, dateUtil_1.getClosingViewDate(newViewDate, picker, generateConfig, -1), activePickerIndex));
        }
      }));
    }

    return React.createElement("div", {
      className: "".concat(prefixCls, "-panel-container"),
      ref: panelDivRef
    }, renderPanel());
  }

  var arrowLeft = 0;

  if (activePickerIndex && startInputDivRef.current && separatorRef.current) {
    // Arrow offset
    arrowLeft = startInputDivRef.current.offsetWidth + separatorRef.current.offsetWidth;
  }

  var rangePanel = React.createElement("div", {
    style: {
      minWidth: popupMinWidth
    }
  }, React.createElement("div", {
    className: "".concat(prefixCls, "-range-arrow"),
    style: {
      left: arrowLeft
    }
  }), renderPanels());
  var suffixNode;

  if (suffixIcon) {
    suffixNode = React.createElement("span", {
      className: "".concat(prefixCls, "-suffix")
    }, suffixIcon);
  }

  var clearNode;

  if (allowClear && (miscUtil_1.getValue(mergedValue, 0) && !mergedDisabled[0] || miscUtil_1.getValue(mergedValue, 1) && !mergedDisabled[1])) {
    clearNode = React.createElement("span", {
      onClick: function onClick(e) {
        e.stopPropagation();
        var values = mergedValue;

        if (!mergedDisabled[0]) {
          values = miscUtil_1.updateValues(values, null, 0);
        }

        if (!mergedDisabled[1]) {
          values = miscUtil_1.updateValues(values, null, 1);
        }

        triggerChange(values, false);
      },
      className: "".concat(prefixCls, "-clear")
    }, clearIcon || React.createElement("span", {
      className: "".concat(prefixCls, "-clear-btn")
    }));
  }

  var inputSharedProps = {
    size: uiUtil_1.getInputSize(picker, formatList[0])
  };
  var activeBarLeft = 0;
  var activeBarWidth = 0;

  if (startInputDivRef.current && endInputDivRef.current && separatorRef.current) {
    if (activePickerIndex === 0) {
      activeBarWidth = startInputDivRef.current.offsetWidth;
    } else {
      activeBarLeft = arrowLeft;
      activeBarWidth = endInputDivRef.current.offsetWidth;
    }
  }

  return React.createElement(PanelContext_1.default.Provider, {
    value: {
      operationRef: operationRef,
      hideHeader: picker === 'time',
      onDateMouseEnter: onDateMouseEnter,
      onDateMouseLeave: onDateMouseLeave
    }
  }, React.createElement(PickerTrigger_1.default, {
    visible: mergedOpen,
    popupElement: rangePanel,
    popupStyle: popupStyle,
    prefixCls: prefixCls,
    dropdownClassName: dropdownClassName,
    dropdownAlign: dropdownAlign,
    getPopupContainer: getPopupContainer,
    transitionName: transitionName,
    range: true
  }, React.createElement("div", Object.assign({
    ref: containerRef,
    className: classnames_1.default(prefixCls, "".concat(prefixCls, "-range"), className, (_classnames_1$default2 = {}, _defineProperty(_classnames_1$default2, "".concat(prefixCls, "-disabled"), mergedDisabled[0] && mergedDisabled[1]), _defineProperty(_classnames_1$default2, "".concat(prefixCls, "-focused"), startFocused || endFocused), _classnames_1$default2)),
    style: style
  }, miscUtil_1.default(props)), React.createElement("div", {
    className: classnames_1.default("".concat(prefixCls, "-input"), _defineProperty({}, "".concat(prefixCls, "-input-active"), activePickerIndex === 0)),
    ref: startInputDivRef
  }, React.createElement("input", Object.assign({
    disabled: mergedDisabled[0],
    readOnly: inputReadOnly || !startTyping,
    value: startText,
    onChange: triggerStartTextChange,
    autoFocus: autoFocus,
    placeholder: miscUtil_1.getValue(placeholder, 0) || '',
    ref: startInputRef
  }, startInputProps, inputSharedProps))), React.createElement("div", {
    className: "".concat(prefixCls, "-range-separator"),
    ref: separatorRef
  }, separator), React.createElement("div", {
    className: classnames_1.default("".concat(prefixCls, "-input"), _defineProperty({}, "".concat(prefixCls, "-input-active"), activePickerIndex === 1)),
    ref: endInputDivRef
  }, React.createElement("input", Object.assign({
    disabled: mergedDisabled[1],
    readOnly: inputReadOnly || !endTyping,
    value: endText,
    onChange: triggerEndTextChange,
    placeholder: miscUtil_1.getValue(placeholder, 1) || '',
    ref: endInputRef
  }, endInputProps, inputSharedProps))), React.createElement("div", {
    className: "".concat(prefixCls, "-active-bar"),
    style: {
      left: activeBarLeft,
      width: activeBarWidth,
      position: 'absolute'
    }
  }), suffixNode, clearNode)));
} // Wrap with class component to enable pass generic with instance method


var RangePicker =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RangePicker, _React$Component);

  function RangePicker() {
    var _this;

    _classCallCheck(this, RangePicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RangePicker).apply(this, arguments));
    _this.pickerRef = React.createRef();

    _this.focus = function () {
      if (_this.pickerRef.current) {
        _this.pickerRef.current.focus();
      }
    };

    _this.blur = function () {
      if (_this.pickerRef.current) {
        _this.pickerRef.current.blur();
      }
    };

    return _this;
  }

  _createClass(RangePicker, [{
    key: "render",
    value: function render() {
      return React.createElement(InnerRangePicker, Object.assign({}, this.props, {
        pickerRef: this.pickerRef
      }));
    }
  }]);

  return RangePicker;
}(React.Component);

exports.default = RangePicker;